package main

import (
	"fmt"
	"time"
	"math/rand"
)

func permute(base string, chars []rune) {
	if len(chars) == 1 {
		fmt.Println(base+string(chars))
		return
	}

	nextLetter := rand.Intn(len(chars))

	remaining := []rune(string(chars[:nextLetter])+string(chars[nextLetter+1:]))
	permute(base+string(chars[nextLetter]),remaining)
}


func main(){
	var word string

	fmt.Println("Insert a word")
	fmt.Scan(&word)

	//initialize rand
	rand.Seed(time.Now().UnixNano())

	var chars []rune = []rune(word)

	permute("", chars)
}
