package main

import "fmt"

func permute(base string, chars []rune) {
	if len(chars) == 1 {
		fmt.Println(base+string(chars))
		return
	}
	
	for i, _ := range chars { //for every position
		remaining := []rune(string(chars[:i])+string(chars[i+1:]))
		permute(base+string(chars[i]),remaining)
	}
}


func main(){
	var word string

	fmt.Println("Insert a word")
	fmt.Scan(&word)
	
	var chars []rune = []rune(word)

	permute("", chars)
}
